<template>
  <!-- 九小场所添加 -->
  <div>
    <el-dialog :close-on-click-modal="false" :title="title + '重点单位'" :visible.sync="showFormDia" width="76%"
      :before-close="handleClose" top="8vh">
      <div>
        <el-form ref="formInfo" :rules="rules" :model="params" label-width="120px">
          <p id="step1" class="from-title">
            <i class="el-icon-info" />
            <span>基本信息</span>
          </p>
          <el-row>
            <el-col :span="6">
              <el-form-item label="单位名称" prop="unitName">
                <el-input v-model="params.unitName" maxlength="60" placeholder="请输入单位名称" show-word-limit />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="法人/负责人" prop="name">
                <el-input v-model="params.name" maxlength="32" placeholder="请输入法人/负责人" show-word-limit />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="联系电话">
                <el-input v-model="params.phone" maxlength="32" placeholder="请输入联系电话" show-word-limit clearable />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="重点单位类别" prop="emphasisType">
                <el-select v-model="params.emphasisType" style="width:100%" clearable>
                  <el-option v-for="item in zddwlbList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>

          <!-- <el-row>
            <el-col :span="6">
              <el-form-item label="重点单位分类" prop="emphasisTypeList">
                <el-select
                  v-model="params.emphasisTypeList"
                  style="width:100%"
                  clearable
                  multiple
                >
                  <el-option
                    v-for="item in zddwflList"
                    :key="item.value"
                    :label="item.name"
                    :value="item.value"
                  />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="安全隐患分类" prop="content">
                <el-select
                  v-model="params.content"
                  style="width:100%"
                  clearable
                >
                  <el-option
                    v-for="item in aqyhlxList"
                    :key="item.value"
                    :label="item.name"
                    :value="item.value"
                  />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row> -->
          <el-row>
            <el-col :span="6">
              <el-form-item label="重点单位级别" prop="emphasisLevel">
                <el-select v-model="params.emphasisLevel" style="width:100%" clearable>
                  <el-option v-for="item in zddwjbList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="单位地址" prop="unitAddress">
                <el-input v-model="params.unitAddress" maxlength="80" placeholder="请输入单位地址" show-word-limit />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="风险级别" prop="riskLevel">
                <el-select v-model="params.riskLevel" style="width:100%" clearable>
                  <el-option v-for="item in fxjbList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <!-- <el-col :span="6">
              <el-form-item label="场所面积(m²)" prop="area">
                <el-input v-model="params.area" placeholder="请输入场所面积" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="从业员工数量" prop="employees">
                <el-input
                  v-model="params.employees"
                  placeholder="请输入从业员工数量"
                />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="道路门牌号" prop="roadNum">
                <el-input
                  v-model="params.roadNum"
                  placeholder="请输入道路门牌号"
                />
              </el-form-item>
            </el-col> -->
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item prop="region" label="所属区域">
                <el-cascader clearable ref="cascaderArea" v-if="areaOptions" v-model="params.region"
                  placeholder="请选择所属区域" :options="areaOptions" :props="{
                    value: 'id',
                    label: 'name',
                    checkStrictly: true,
                  }" @change="handleChange()" style="width: 100%"></el-cascader>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item prop="longitude" label="经度">
                <el-input maxlength="10" show-word-limit clearable placeholder="请输入经度" v-model="params.longitude"
                  @input="formatNumber('longitude')"></el-input>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item prop="latitude" label="纬度">
                <el-input maxlength="10" show-word-limit clearable placeholder="请输入纬度" v-model="params.latitude"
                  @input="formatNumber('latitude')"></el-input>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="经营状态">
                <el-select v-model="params.status" style="width:100%" clearable>
                  <el-option v-for="item in jyztList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <el-form-item label="备注" prop="memo">
                <el-input v-model="params.memo" :rows="3" maxlength="500" show-word-limit type="textarea"
                  style="width:100%;" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-form-item label>
              <el-button type="primary" @click="setPosition">设置点位</el-button>
            </el-form-item>
          </el-row>
        </el-form>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleSave">保 存</el-button>
        <el-button @click="handleClose">取 消</el-button>
      </span>
    </el-dialog>
    <!-- 选择点位地图弹层 -->
    <ChooseMapPointVue ref="mapDialog" @getPosition="getPosition"></ChooseMapPointVue>
  </div>
</template>
<script>
import nineLittlePlaceApi from '@/views/Manage/saftyDanger/api/nineLittlePlaceApi'
import dictContracts from '@/components/dict/DictSelectUtils.js'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import ChooseMapPointVue from '@/views/Device/deviceManage/components/ChooseMapPoint'
import resourceManage from '@/api/device/resourceManage.js'
import latitude from '@/mixins/latitude'

export default {
  name: 'CmgtSaftyDangerUnitFormDialog',
  components: { ChooseMapPointVue },
  props: {},
  data() {
    let validatePhone = (rule, value, callback) => {
      let phoneReg = /^1([3456789])\d{9}$/ // 手机
      if (!phoneReg.test(value)) {
        callback(new Error('联系电话不合法'))
      } else {
        callback()
      }
    }

    return {
      title: '新增',
      showFormDia: false,
      activeCollapseNames: ['1'],
      // emphasisType: [],
      params: {
        // type:null,
        unitName: null,
        unitAddress: null,
        name: null,
        phone: null,
        // emphasisType: null,
        // smallPlaceType: null,
        // smallPlaceArea: null,
        // area: null,
        // employees: null,
        // roadNum: null,
        // isShy: null,
        // content: null,
        riskLevel: null,
        status: null,
        // fuelType: null,
        memo: null,
        type: 2,
        longitude: '', // 经度
        latitude: '', // 纬度
        region: '' // 区域id
        // emphasisTypeList: []
      },
      rules: {
        // type: [{
        // 	required: true,
        // 	message: '单位类别不能为空',
        // 	trigger: 'blur'
        // }],
        unitName: [
          {
            required: true,
            message: '单位名称不能为空',
            trigger: 'blur'
          }
        ],
        name: [
          {
            required: true,
            message: '负责人不能为空',
            trigger: 'blur'
          }
        ],
        phone: [
          {
            required: true,
            message: '联系电话不能为空',
            trigger: ['blur', 'change']
          },
          {
            validator: validatePhone,
            trigger: ['blur', 'change']
          }
        ],
        unitAddress: [
          {
            required: true,
            message: '单位地址不能为空',
            trigger: 'blur'
          }
        ],
        emphasisLevel: [
          {
            required: true,
            message: '重点单位级别不能为空',
            trigger: 'blur'
          }
        ],
        emphasisType: [
          {
            required: true,
            message: '重点单位类别不能为空',
            trigger: 'blur'
          }
        ],
        content: [
          {
            required: true,
            message: '安全隐患分类不能为空',
            trigger: 'blur'
          }
        ],
        riskLevel: [
          {
            required: true,
            message: '风险级别不能为空',
            trigger: 'blur'
          }
        ],
        region: [
          {
            required: true,
            message: '所属区域不能为空',
            trigger: 'blur'
          }
        ]
      },
      // levels: [],
      types: [],
      zddwlbList: []
    }
  },
  created() {
    this.types = dictContracts.getDictItemsFromCache('cmgt_aqyhpcdwlb')
    this.fxjbList = dictUtils.getDictItemsFromCache('fxjb') //风险级别
    this.zddwflList = dictUtils.getDictItemsFromCache('zddwfl') //重点单位分类
    this.jxcslxList = dictUtils.getDictItemsFromCache('jxcslx') //九小场所类型
    this.jxcspqList = dictUtils.getDictItemsFromCache('jxcspq') //九小场所片区
    this.rlzlList = dictUtils.getDictItemsFromCache('rlzl') //燃料种类
    this.tysfList = dictUtils.getDictItemsFromCache('ty-sf') //是否三合一
    this.aqyhlxList = dictUtils.getDictItemsFromCache('cmgt_aqyhlx') //安全隐患
    this.zddwjbList = dictUtils.getDictItemsFromCache('zddwjb') //重点单位级别
    this.jyztList = dictUtils.getDictItemsFromCache('jyzt') //重点单位级别
    this.zddwlbList = dictUtils.getDictItemsFromCache('zddwlb') //重点单位级别

    this.loadArea()

    // this.levels = dictContracts.getDictItemsFromCache('cmgt_aqyhfxjb')
  },
  methods: {
    // 获取所属区域
    loadArea() {
      this.areaOptions = []
      resourceManage.loadAreaTree({ id: '0' }, res => {
        // console.log(res, 'res')
        this.areaOptions = res.value
      })
    },
    add() {
      this.showFormDia = true
      // this.params.emphasisTypeList = []
      // this.params.emphasisTypeList.push(this.zddwflList[0].value)
      // this.params.riskLevel = this.fxjbList[0].value
      // this.params.content = this.aqyhlxList[0].value
      // this.params.emphasisLevel = this.zddwjbList[0].value
      // this.params.fuelType = this.rlzlList[0].value
      // this.params.isShy = this.tysfList[0].value
    },
    handleClose() {
      this.params = {
        type: 2,
        unitName: null,
        unitAddress: null,
        name: null,
        phone: null,
        // emphasisType: null,
        // smallPlaceType: null,
        // smallPlaceArea: null,
        // area: null,
        // employees: null,
        // roadNum: null,
        // isShy: null,
        content: null,
        riskLevel: null,
        status: null,
        // fuelType: null,
        memo: null,
        longitude: '', // 经度
        latitude: '', // 纬度
        region: '' // 区域id
        // emphasisTypeList: []
      }
      this.$refs.formInfo.clearValidate()
      this.title = '新增'
      this.showFormDia = false
    },
    handleSave() {
      let params = JSON.parse(JSON.stringify(this.params))
      this.$refs.formInfo.validate(valid => {
        if (valid) {
          let method
          if (!this.params.id) {
            // 新增
            method = nineLittlePlaceApi.addCmgtSaftyDangerUnit
          }
          if (this.params.id) {
            // 修改
            method = nineLittlePlaceApi.editCmgtSaftyDangerUnit
          }
          method(params, res => {
            if (res.state) {
              this.$notify({
                type: 'success',
                message: this.title + '成功',
                duration: 2000
              })
              // this.$emit('loadData')
              this.$parent.loadData()
              this.$parent.getStatisticsData()
              this.handleClose()
            } else {
              this.$message.warning(res.message)
            }
          })
        }
      })
    },
    Update(row) {
      console.log(row)
      this.title = '修改'
      this.showFormDia = true
      nineLittlePlaceApi.getItemById(row.id, res => {
        // this.params = res
        // console.log(res.emphasisType.split(','));
        this.params.id = res.id
        this.params.unitName = res.unitName
        this.params.unitAddress = res.unitAddress
        this.params.name = res.name
        this.params.phone = res.phone
        // this.params.emphasisType = res.emphasisType
        // this.params.smallPlaceType=res.smallPlaceType
        // this.params.smallPlaceArea=res.smallPlaceArea
        this.params.area = res.area
        this.params.employees = res.employees
        this.params.roadNum = res.roadNum
        // this.params.isShy=res.isShy
        this.params.content = res.content
        this.params.riskLevel = res.riskLevel
        this.params.status = res.status ? res.status + '' : ''
        // this.params.fuelType=res.fuelType
        // this.params.emphasisLevel = res.emphasisLevel
        this.$set(this.params, 'emphasisType', res.emphasisType)
        this.$set(this.params, 'emphasisLevel', res.emphasisLevel)
        this.params.memo = res.memo,
          this.params.longitude = res.longitude
        this.params.latitude = res.latitude
        this.params.region = res.region
        // this.params.emphasisTypeList = res.emphasisType.split(',')
        this.$set(this.params)
      })
    },
    // 打开地图选点弹层，设置点位
    setPosition() {
      this.$refs.mapDialog.handleOpen(this.params)
    },
    getPosition(data) {
      this.params.longitude = data.lgtd + ''
      this.params.latitude = data.lttd + ''
      this.params.region = data.areaCode
      this.$forceUpdate()
    },
    handleChange() {
      let nodes = this.$refs.cascaderArea.getCheckedNodes()
      if (nodes && nodes.length > 0) {
        this.params.region = nodes[0].data.id
      } else {
        this.$refs.cascaderArea.$refs.panel.clearCheckedNodes()
        this.$refs.cascaderArea.$refs.panel.checkedValue = '' // 清空选中值
        this.$refs.cascaderArea.$refs.panel.activePath = '' // 清除高亮
        this.$refs.cascaderArea.$refs.panel.syncActivePath() // 初始化（只展示一级节点）
        this.params.region = ''
      }
      this.$forceUpdate()

    },
    formatNumber(key) {
      this.params[key] = latitude.TreeFour(this.params[key])
    }
  }
}
</script>
<style lang="scss" scoped>
.step-container {
  width: 80%;
  margin: 0 auto 20px;
}

.dialog-footer {
  text-align: center;
}
</style>
